#!/usr/bin/env python
#
# This file is part of Spelling Bee
# Author(s): Katie Lemon, Girlstart
# Copyright 2008
#
# Source code is derived from Girlstart's Project IT Girl Game Templates:
# http://itgirl.dreamhosters.com/itgirlgames/, http://www.girlstart.org/itgirl
# See the credits file for image sources.
#
# Spelling Bee is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Spelling Bee is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Spelling Bee.  If not, see <http://www.gnu.org/licenses/>.

import pygame, random, datetime,time
from helpers import *
from questions import *


class ActivityGenerator(pygame.sprite.Sprite):
	def __init__(self,background_image):
		pygame.sprite.Sprite.__init__(self)
		self.screen = pygame.display.get_surface()
		self.area = self.screen.get_rect()
		self.background = background_image
		
		self.score = 0
		self.activity_count = 0
		self.correct_answer_count = 0
		
		self.index=0
		
		
		self.time_left=60
		self.game_length_in_seconds=60
		self.time_started=False

	def good_effect(self):
		self.score = self.score + 1
		display_static_image('bumble_bee copy.png',1,self.screen,self.background,self.area)

	def tryagain_effect(self):
		self.score = self.score - 1
		display_static_image('bumble_bee try again.png',1,self.screen,self.background,self.area)

	def bad_effect(self):
		self.score = self.score - 1
		display_static_image('bumble_bee wrong.png',1,self.screen,self.background,self.area)
		
	def play(self,correct_answer):
		#default play will ask the user to press a specific key to complete the activity
		answered_correctly = False
		activity_completed = False
		finished = False
		#game_length_in_seconds=5
		#start_time=datetime.datetime.today()
		#end_time=start_time + datetime.timedelta(0,game_length_in_seconds)
		
		
		

		
		while not finished:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					activity_completed = True
					if event.key == ord(correct_answer):
						answered_correctly = True
						finished=True
		
			# Draw everything to the screen
			self.screen.blit(self.background, (0, 0))

			font = pygame.font.Font(None, 30)
			text = font.render("Press the '" + correct_answer + "' key to complete this activity correctly.", 1, (0,0,0))
			textrect = text.get_rect()
			textrect.centerx, textrect.centery = self.area.centerx,self.area.centery
			self.screen.blit(text, textrect)
			#time_left = datetime.timedelta(0,game_length_in_seconds) - (datetime.datetime.today() - start_time)
			#time_left_string = time.strftime("%M:%S",time.gmtime(time_left.seconds))
			#font = pygame.font.Font("data/fonts/Gentium.ttf", 100)
			#text = font.render("Time: " + time_left_string, 1, (0,0,0))
			#textrect = text.get_rect()
			#textrect.left, textrect.top = 0,0
			#screen.blit(text, textrect)
			
			pygame.display.flip()
			#if activity_completed==True:
				#finished=True
			#if datetime.datetime.today()<end_time:
				#finished=True

		self.activity_count += 1
		if answered_correctly:
			self.correct_answer_count += 1
		return answered_correctly
	
	def ask_question(self,correct_answer):
		answered_correctly = False
		activity_completed = False
		x=1

		user_answer=""
		
		while not activity_completed:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
				elif event.type == pygame.KEYDOWN:
					if event.key == K_RETURN:
						#activity_completed = True
						#answered_correctly = (string.lower(user_answer) == string.lower(str(correct_answer)))
#						print user_answer 
#						print correct_answer
						if correct_answer == user_answer:
							print "correct"
							answered_correctly=True
							activity_completed = True
							x=1
						else:
							
							x=x+1
							user_answer=""
							if x>2:
								x=1
								self.screen.blit(self.background, (0, 0))
								pygame.display.flip()
								activity_completed=True
							else:
								self.tryagain_effect()
							
							
							
					elif event.key == K_BACKSPACE:
						user_answer = user_answer[0:-1]
					elif event.key in range(256):
						user_answer += chr(event.key)
						
			self.time_left = datetime.timedelta(0,self.game_length_in_seconds) - (datetime.datetime.today() - self.start_time)
		
			time_left_string = time.strftime("%M:%S",time.gmtime(self.time_left.seconds))
	
			if self.time_left.seconds == 0:
				self.time_up_screen()

	
			font = pygame.font.Font("data/fonts/Breip.ttf", 50)
			text = font.render("Time: " + time_left_string, 1, (1,1,1))
			textrect = text.get_rect()
			textrect.left, textrect.top = 500,10
			#time_left = datetime.timedelta(0,60) - (datetime.datetime.today() - start_time)
			#time_left_string = time.strftime("%M:%S",time.gmtime(time_left.seconds))
			#font = pygame.font.Font("data/fonts/Gentium.ttf", 100)
			#text = font.render("Time: " + time_left_string, 1, (255,255,255))
			#textrect = text.get_rect()
			#textrect.left, textrect.top = 0,0
			#screen.blit(text, textrect)
			
			# Draw everything to the screen
			self.screen.blit(self.background, (0, 0))
			self.screen.blit(text, textrect)

			# Draw the question
			self.screen.blit(self.image,self.rect)

			# Give instructions for submitting the answer
			font = pygame.font.Font("data/fonts/Breip.ttf", 50)
			text = font.render("Press Enter to submit your answer.", 1, (0,0,0))
			textrect = text.get_rect()
			textrect.centerx, textrect.centery = self.area.centerx,self.area.centery
			textrect.centery += 100
			self.screen.blit(text, textrect)

			# Draw the user's input
			font = pygame.font.Font("data/fonts/Breip.ttf", 70)
			text = font.render(user_answer, 1, (0,0,255))
			textrect = text.get_rect()
			textrect.centerx = self.area.centerx
			textrect.centery = self.area.centery + 200
			self.screen.blit(text, textrect)
			
			pygame.display.flip()
		return answered_correctly
	


	#def generate_activity(self):
		#correct_answer = chr(random.randint(97,122))
		#if self.play(correct_answer):
			#self.good_effect()
		#else:
			#self.bad_effect()
			
	def generate_word(self):
		if not self.time_started:
			self.start_time = datetime.datetime.today()
			self.end_time = self.start_time + datetime.timedelta(0,self.game_length_in_seconds)
			self.time_started = True

		correct_answer = answer_array[self.index]
		self.image,self.rect=load_image(picture_array[self.index])
		self.rect.center=(400,200)
		if self.ask_question(correct_answer):
			self.good_effect()
		else:
			self.bad_effect()
			#font=pygame.font.Font("data/fonts/Gentium.ttf",100)
			#text=font.render("Time:", 1, (255,255,255))
			#textrect=text.get_rect()
			#screen.blit(text,textrect)
		self.index=self.index+1
		
	def time_up_screen(self):
		# Draw everything to the screen
		self.screen.blit(self.background, (0, 0))
			
		# Tell the user their time is up
		font = pygame.font.Font("data/fonts/Breip.ttf", 70)
		text = font.render("Thanks for playing!", 1, (0,0,0))
		textrect = text.get_rect()
		textrect.centerx, textrect.centery = self.area.centerx,self.area.centery
		textrect.centery += 100
		self.screen.blit(text, textrect)

		# Display background and text on the screen
		pygame.display.flip()
		
		# Don't do anything else until the user quits
		while True:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit()
	
